// SPDX-License-Identifier: Unlicense
pragma solidity ^0.8.24;

struct Post {
    uint id;
    address sender;
    address author;
    string contentId;
    // TODO: citations
}

contract Forum {
    mapping(uint => Post) public posts;
    uint public postCount;

    event PostAdded(uint postIndex);

    function addPost(
        address author,
        string calldata contentId
    ) external returns (uint postIndex) {
        postIndex = postCount++;
        Post storage post = posts[postIndex];
        post.author = author;
        post.sender = msg.sender;
        post.id = postIndex;
        post.contentId = contentId;
        emit PostAdded(postIndex);
    }
}
